function FriendsList(_1,id,_3,_4,_5){
FriendsList.baseConstructor.call(this,id);
this.offset=0;
this.limit=10;
this.orderBy=_3;
this.lastResultsCount=0;
this.condition=_4;
this.needsPhone=_5;
this.phoneBookStyle=_3=="last_name";
this.prevButton=$("friendsPrevPage");
this.nextButton=$("friendsNextPage");
this.loader=new InlineLoader(_1);
};
Helper.extend(FriendsList,Container);
FriendsList.prototype.onActivated=function(){
FriendsList.base.onActivated.call(this);
this.clearScreen();
};
FriendsList.prototype.reset=function(){
this.clearScreen();
};
FriendsList.prototype.getItemCount=function(){
return this.lastResultsCount;
};
FriendsList.prototype.reload=function(_6,_7){
this.filter=_6;
this.clearScreen();
var _8=this;
var _9={nocache:_7,offset:this.offset,limit:this.limit,orderBy:this.orderBy,filterByName:_6,needsPhone:this.needsPhone,condition:this.condition,order:this.orderBy=="status.time"?"desc":null,loader:this.loader,onSuccess:function(_a){
_8.onFriendsDataReceived(_a);
},onError:function(_b){
_8.onFriendsError(_b);
}};
if(!_6){
_9.cacheKey=this.id;
}
facebook.getFriendList(_9);
this.invalidate();
};
FriendsList.prototype.getEmptyMessage=function(){
var _c=document.createElement("div");
_c.className="no_data";
if(this.filter){
$(_c).setText("None of you friends matches '"+this.filter+"'");
}else{
$(_c).setText("No friends.");
}
return _c;
};
FriendsList.prototype.getSummaryMessage=function(_d,_e,_f){
var _10=document.createElement("span");
var _11=_e+" - "+_f+" of "+_d+" friends ";
if(this.filter){
_11+=" that match '"+this.filter+"'";
}
$(_10).setText(_11);
return _10;
};
FriendsList.prototype.onFriendsDataReceived=function(_12){
this.clearScreen();
this.lastResultsCount=_12.friendsCount;
var _13=$("friends_content");
_13.removeChildren();
if(!_12.length){
var _14=document.createElement("center");
_14.appendChild(this.getEmptyMessage());
_13.appendChild(_14);
return;
}
var _15=this;
var _16=null;
var _17=null;
for(var i=0;i<_12.length;i++){
var _19=_12[i];
if(this.phoneBookStyle){
var _1a=_19.last_name||"";
var _1b=_1a.length>0?_1a.charAt(0):"";
if(_1b!=_17){
var _1c=this.createHeader(_1b);
_13.appendChild(_1c);
_17=_1b;
}
}
var _1d=this.phoneBookStyle?(_19.cell||_19.phone):null;
var row=this.createRow(_19,_1d,_16);
_13.appendChild(row);
if(!_16){
_16=row;
}
}
var _1f=uiManager.get("friends");
if(!_1f.getSelected()){
_1f.setSelected(_16);
}
this.setupPagination();
_1f.invalidate();
};
FriendsList.prototype.setupPagination=function(){
var _20=this.getItemCount();
var _21=!this.filter&&_20>=this.limit;
var _22=_20<(this.offset+this.limit)?_20:this.offset+this.limit;
if(_20>0){
$("friendsSummary").removeChildren();
$("friendsSummary").appendChild(this.getSummaryMessage(_20,(this.offset+1),_22));
$("friendsSummary").show(true);
}else{
$("friendsSummary").show(false);
}
var _23=$("friendsPaginationTable");
if(_21){
var _24=Math.ceil(_20/this.limit);
var _25=Math.ceil(this.offset/this.limit)+1;
this.prevButton.show(this.offset>0);
this.nextButton.show(this.offset+this.limit<_20);
var _26="Page "+_25+" of "+_24;
$("paginationPageText").innerHTML=_26;
_23.show(true);
}else{
_23.show(false);
}
};
FriendsList.prototype.createHeader=function(_27){
var tr=document.createElement("tr");
tr.className="letter";
var td=document.createElement("td");
td.colSpan="4";
td.innerHTML=_27.length?_27:"#";
tr.appendChild(td);
return tr;
};
FriendsList.prototype.createRow=function(_2a,_2b){
var tr=document.createElement("tr");
tr.className="friend n";
tr.setAttribute("id","friend_item");
var td=document.createElement("td");
td.className="friends_pic";
if(_2a.pic_square&&_2a.pic_square.length){
td.innerHTML="<img src='"+_2a.pic_square+"'/>";
}else{
if(_2a.pic){
td.innerHTML="<img src='"+_2a.pic+"'/>";
}else{
td.innerHTML="<img src='images/3_2/user_default_square.png'/>";
}
}
tr.appendChild(td);
td=document.createElement("td");
var div=document.createElement("div");
div.className="friends_name";
if(_2a.name){
$(div).setText(_2a.name);
}else{
$(div).setText(_2a.first_name+" "+_2a.last_name);
}
td.appendChild(div);
if(_2a.status&&_2a.status.message&&_2a.status.message.length){
div=document.createElement("div");
div.className="friends_status";
$(div).setText(_2a.status.message);
td.appendChild(div);
}
tr.appendChild(td);
td=document.createElement("td");
td.className="friends_arrow_column";
td.innerHTML="<div class='arrow'></div>";
tr.appendChild(td);
tr.uid=_2a.uid;
tr.name=_2a.name;
var _2f=this;
Events(tr).setAction(function(){
if(_2f._itemClicked){
_2f._itemClicked(tr.uid,tr.name);
}
});
return tr;
};
FriendsList.prototype.onFriendsError=function(err){
this.clearScreen();
alert("Could not retrieve your friends. Error: "+err);
};
FriendsList.prototype.clearScreen=function(){
$("friendsSummary").show(false);
$("friendsPaginationTable").show(false);
$("friends_content").removeChildren();
};
function FriendsStatusList(_31){
var ret=new FriendsList(_31,"friends_status_list","status.time","strlen(status.message) > 0");
ret.getEmptyMessage=function(){
var div=document.createElement("div");
div.className="no_data";
if(ret.filter){
$(div).setText("None of you friends with recent status updates matches '"+this.filter+"'");
}else{
$(div).setText("No friends with recent status updates");
}
return div;
};
ret.getSummaryMessage=function(_34,_35,end){
var _37=document.createElement("span");
var _38=_35+" - "+end+" of "+_34+" friends with status updates";
if(this.filter){
_38+=" that match '"+this.filter+"'";
}
$(_37).setText(_38);
return _37;
};
return ret;
};
function FriendsFindList(_39){
var ret=new FriendsList(_39,"friends_find");
ret.reload=function(_3b){
this.filter=_3b;
this.clearScreen();
if(!this.filter){
this.findQueryCount=0;
this.onFriendsDataReceived([]);
return;
}
var _3c=this;
var _3d={offset:this.offset,limit:this.limit,filter:_3b,loader:this.loader,onSuccess:function(_3e){
var _3f=parseInt(_3e.total);
if(_3f<this.limit){
_3f=_3e.results.length;
}
_3c.findQueryCount=_3f;
_3c.onFriendsDataReceived(_3e.results);
},onError:function(err){
_3c.onFriendsError(err);
}};
facebook.findFriends(_3d);
};
ret.getEmptyMessage=function(){
var div=document.createElement("div");
div.className="no_data";
if(ret.filter){
$(div).setText("There are no results for '"+this.filter+"'");
}else{
$(div).setText("Enter a name");
}
return div;
};
ret.getItemCount=function(){
return this.findQueryCount;
};
return ret;
};
