function PhotoGallery(){
PhotoGallery.baseConstructor.call(this,"photo_gallery","photo_gallery_title","photo_gallery_container",{elementId:"photo_gallery_pagination_table",titleId:"photo_gallery_page_text",prevBtnId:"photo_gallery_prev_page",nextBtnId:"photo_gallery_next_page"});
this.photos=[];
this.currentPhotos=[];
this.currentIndex=0;
this.photosTaken=false;
};
Helper.extend(PhotoGallery,PhotoMatrixBase);
PhotoGallery.prototype.onActivated=function(_1){
PhotoGallery.base.onActivated.call(this);
this.photosTitle.innerHTML="Gallery";
var _2=this;
if(_1||!this.photos.length||this.photosTaken){
this.photosTaken=false;
var _3={Type:"FileInfo",Filter:{FileType:"Image"},Sort:{Key:"FileDate",Order:"Descending"}};
this.mediaManager=new AsyncJob(MediaManager);
this.mediaManager.onSuccess=function(_4){
_2.onPhotosRetrievedSuccessfully(_4);
};
this.mediaManager.onError=function(_5){
alert(_5);
};
this.mediaManager.startAsync(_3,new LoadingPopup(pr_reading_photos),true);
}
};
PhotoGallery.prototype.onDeactivated=function(){
PhotoGallery.base.onDeactivated.call(this);
};
PhotoGallery.prototype.onPhotosRetrievedSuccessfully=function(_6){
this.clearScreen();
var _7=null;
this.photos=[];
_6.reset();
while(_7=_6.getNext()){
if(_7.MimeType!=="image/jpeg"){
if(PhotoGallery.log.isDebugEnabled()){
PhotoGallery.log.debug("Ignoring image "+_7.FileNameAndPath+"with MIME type "+_7.MimeType);
}
continue;
}
if(PhotoGallery.log.isDebugEnabled()){
PhotoGallery.log.debug("Device photos: "+_7.FileNameAndPath);
}
this.photos.push(_7);
}
this.pager.setItemCount(this.photos.length);
this.offset=0;
this.photoCount=this.photos.length;
this.layoutPhotos();
};
PhotoGallery.prototype.layoutPhotos=function(){
var _8=this.pager.offset;
var _9=_8+this.pager.itemsPerPage;
var _a=this.photos.slice(_8,_9);
var _b=this;
for(var i=0;i<_a.length;i++){
var _d=_a[i];
var _e=this.createPhoto(_d);
_a[i].placeholder=_e;
this.photosContainer.appendChild(_e.container);
this.setupCallback(_e.container,_d.FileNameAndPath);
}
this.currentPhotos=_a;
this.currentIndex=0;
this.setupPagination();
this.invalidate();
this._processImages();
};
PhotoGallery.prototype.setupCallback=function(_f,_10){
var _11=this;
Events(_f).setAction(function(){
_11.onImageClicked(_10);
});
};
PhotoGallery.prototype.onImageClicked=function(_12){
if(!_12){
PhotoGallery.log.error("Unable to upload photo since path is not set.");
return;
}
if(PhotoGallery.log.isDebugEnabled()){
PhotoGallery.log.debug("Show fullscreen photo view "+_12);
}
CameraApp.setLastActivePage(this.id);
var _13=this.parent.get("photo_upload_preview");
_13.display(_12);
};
PhotoGallery.prototype._processImages=function(){
if(this.currentIndex>=this.currentPhotos.length){
return;
}
var idx=this.currentIndex++;
var _15=this.currentPhotos[idx];
var _16=this;
var _17=document.createElement("img");
_17.width=61;
_17.height=61;
_17.onload=function(){
if(PhotoGallery.log.isDebugEnabled()){
PhotoGallery.log.debug("Thumbnail loaded "+this.src);
}
clearTimeout(this.loadTimerId);
this.onload=this.onerror=null;
setTimeout(function(){
_16._processImages();
},0);
var _18=_15.placeholder.img.parentNode;
_18.removeChild(_15.placeholder.img);
_18.appendChild(this);
};
_17.onerror=function(){
clearTimeout(this.loadTimerId);
this.onerror=function(){
clearTimeout(this.loadTimerId);
this.onerror=null;
this.src=PhotoGallery.ERROR_IMAGE;
};
FBAPIBridge.resizeImg(_15.FileNameAndPath,61,61,true,function(src){
_17.src=src;
_17.loadTimerId=setTimeout(function(){
_17.onerror.call(_17);
},5000);
},function(){
_17.onerror.call(_17);
});
if(PhotoGallery.log.isDebugEnabled()){
PhotoGallery.log.debug("Unable to load thumbnail (onerror) "+this.src);
}
};
if(PhotoGallery.log.isDebugEnabled()){
PhotoGallery.log.debug("Loading: "+_15.FileNameAndPath);
}
FBAPIBridge.getThumbnail(_15.FileNameAndPath,function(src){
_17.src=src;
_17.loadTimerId=setTimeout(function(){
_17.onerror.call(_17);
},5000);
},function(){
_17.onerror.call(_17);
});
};
PhotoGallery.prototype.nextPage=function(){
PhotoGallery.base.nextPage.call(this);
this.setSelected(null);
this.layoutPhotos();
};
PhotoGallery.prototype.prevPage=function(){
PhotoGallery.base.prevPage.call(this);
this.setSelected(null);
this.layoutPhotos();
};
PhotoGallery.ERROR_IMAGE="images/3_2/image_error_61.png";
PhotoGallery.log=Logger.getLogger("PhotoGallery");
