function DevicePhotos(){
DevicePhotos.baseConstructor.call(this,"device_photos","content");
var _1=this;
this.btnCameraButton=this.add("device_photos_camera_button");
this.btnCameraButton.onclicked=function(){
CameraApp.takePhoto(_1.id);
};
this.prevButton=$("devicePhotosPrevPage");
this.prevButton.onclick=function(){
_1.prevPage();
};
this.nextButton=$("devicePhotosNextPage");
this.nextButton.onclick=function(){
_1.nextPage();
};
this.pager=new Pager(12);
this.photos=[];
this.currentPhotos=[];
this.currentIndex=0;
this.session=0;
this.photosTaken=false;
};
Helper.extend(DevicePhotos,FormWithBack);
DevicePhotos.prototype.onActivated=function(_2){
DevicePhotos.base.onActivated.call(this);
var _3=this;
this.injectBackButton(function(){
_3.onBackSoftMenu();
});
this.btnCameraButton.element.show(true);
if(_2||!this.photos.length||this.photosTaken){
this.photosTaken=false;
var _4={Type:"FileInfo",Filter:{FileType:"Image"},Sort:{Key:"FileDate",Order:"Descending"}};
this.mediaManager=new AsyncJob(MediaManager);
this.mediaManager.onSuccess=function(_5){
_3.onPhotosRetrievedSuccessfully(_5);
};
this.mediaManager.onError=function(_6){
alert(_6);
};
this.mediaManager.startAsync(_4,new LoadingPopup(pr_reading_photos),true);
}
};
DevicePhotos.prototype.reset=function(){
if(this.mediaManager){
this.mediaManager.setForceUpdate();
}
};
DevicePhotos.prototype.onDeactivated=function(){
this.btnCameraButton.element.show(false);
DevicePhotos.base.onDeactivated.call(this);
};
DevicePhotos.prototype.onPhotosRetrievedSuccessfully=function(_7){
this.clearPhotosContainer();
var _8=null;
this.photos=[];
_7.reset();
while(_8=_7.getNext()){
if(_8.MimeType!=="image/jpeg"){
if(DevicePhotos.log.isDebugEnabled()){
DevicePhotos.log.debug("Ignoring image "+_8.FileNameAndPath+"with MIME type "+_8.MimeType);
}
continue;
}
if(DevicePhotos.log.isDebugEnabled()){
DevicePhotos.log.debug("Device photos: "+_8.FileNameAndPath);
}
this.photos.push(_8);
}
this.pager.setItemCount(this.photos.length);
this.offset=0;
this.photoCount=this.photos.length;
this.layoutPhotos();
};
DevicePhotos.prototype.layoutPhotos=function(){
var _9=this.pager.offset;
var _a=_9+this.pager.itemsPerPage;
var _b=this.photos.slice(_9,_a);
this.preparePlaceholders(_b);
this.currentPhotos=_b;
this.currentIndex=0;
this.setupPagination();
this.session++;
this._processImages();
};
DevicePhotos.prototype.preparePlaceholders=function(_c){
var _d=$("device_photos_container");
for(var i=0;i<_c.length;i++){
var _f=this.createPhoto(_c[i]);
_c[i].placeholder=_f;
_d.appendChild(_f.container);
}
};
DevicePhotos.prototype.createPhoto=function(_10){
var _11=document.createElement("div");
_11.className="image_container";
var img=document.createElement("img");
img.src="images/photo_default.png";
_11.appendChild(img);
var _13=this.add(_11);
var _14=this;
_13._image=_10;
_13.onclicked=function(){
_14.onImageClicked();
};
return {container:_11,img:img};
};
DevicePhotos.prototype._processImages=function(){
if(this.currentIndex>=this.currentPhotos.length){
return;
}
var idx=this.currentIndex++;
var _16=this.currentPhotos[idx];
var _17=this;
var _18=this.session;
var _19=document.createElement("img");
_19.width=88;
_19.height=88;
_19.onload=function(){
this.onload=this.onerror=null;
_17._processImages();
_16.placeholder.container.replaceChild(this,_16.placeholder.img);
};
_19.onerror=function(){
this.onerror=function(){
this.onerror=function(){
this.onerror=null;
_17._processImages();
};
this.src=DevicePhotos.ERROR_IMAGE;
};
FBAPIBridge.resizeImg(_16.FileNameAndPath,88,88,true,function(src){
_19.src=src;
},function(){
_19.onerror.call(_19);
});
};
FBAPIBridge.getThumbnail(_16.FileNameAndPath,function(src){
_19.src=src;
},function(){
_19.onerror.call(_19);
});
};
DevicePhotos.prototype.onImageClicked=function(){
var _1c=this.activeItem._image;
if(!_1c.FileNameAndPath){
DevicePhotos.log.error("Unable to upload photo since path is not set.");
return;
}
if(DevicePhotos.log.isDebugEnabled()){
DevicePhotos.log.debug("Uploading "+_1c.FileNameAndPath);
}
CameraApp.setLastActivePage(this.id);
this.setIgnoreBack();
var _1d=this.parent.get("photo_upload");
_1d.display(_1c.FileNameAndPath);
};
DevicePhotos.prototype.setupPagination=function(){
var _1e=$("devicePhotosPaginationTable");
var _1f=this.pager.getPageCount();
if(_1f>1){
var _20=this.pager.getCurrentPage();
this.prevButton.show(this.pager.hasPrevPage());
this.nextButton.show(this.pager.hasNextPage());
var _21=FBUtils.formatString(lbl_pagination_state,_20,_1f);
$("devicePhotosPageText").innerHTML=_21;
_1e.show(true);
}else{
_1e.show(false);
}
};
DevicePhotos.prototype.nextPage=function(){
this.clearPhotosContainer();
this.setScrollerPos(0);
this.pager.nextPage();
this.layoutPhotos();
this.setupPagination();
};
DevicePhotos.prototype.prevPage=function(){
this.clearPhotosContainer();
this.setScrollerPos(0);
this.pager.prevPage();
this.layoutPhotos();
this.setupPagination();
};
DevicePhotos.prototype.clearPhotosContainer=function(){
$("device_photos_container").removeChildren();
};
DevicePhotos.THUMBNAIL_SIZE=88;
DevicePhotos.log=Logger.getLogger("DevicePhotos");
DevicePhotos.ERROR_IMAGE="images/image_error_88.png";
